; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    include    lib\ifparse.inc
    includelib lib\ifparse.lib

    load_data       PROTO :DWORD
    if2op           PROTO :DWORD,:DWORD
    process_if      PROTO :DWORD,:DWORD,:DWORD
    rt_compares     PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    fn load_data,"iftst.asm"

    ret

main endp

; 

load_data proc fname:DWORD

    LOCAL hFile     :DWORD
    LOCAL flen      :DWORD
    LOCAL buf1      :DWORD
    LOCAL bwrt      :DWORD

    mov hFile, fopen(fname)
    mov flen, fsize(hFile)
    mov buf1, alloc(flen)
    mov bwrt, fread(hFile,buf1,flen)
    fclose hFile

    invoke if2op,buf1,flen

    ret

load_data endp

; 

if2op proc pmem:DWORD,lof:DWORD

    LOCAL buf1      :DWORD
    LOCAL buf2      :DWORD
    LOCAL blen      :DWORD
    LOCAL lbln      :DWORD

  ; -----------------------------------
  ; Append trailing CRLF if not present
  ; -----------------------------------
    mov eax, pmem
    add eax, lof
    sub eax, 2
    cmp WORD PTR [eax], 0A0Dh
    je @F
    add eax, 2
    mov WORD PTR [eax], 0A0Dh
    mov BYTE PTR [eax+3], 0
  @@:
  ; -----------------------------------

    mov eax, lof
    add eax, lof
    mov blen, eax                               ; buffer size is double file size

    mov buf1, rv(GlobalReAlloc,pmem,blen,GMEM_ZEROINIT)
    mov buf2, alloc(blen)

    invoke GlobalSize,buf2                      ; test size of 2nd memory buffer
    cmp eax, blen
    je @F
    print "memory allocation error",13,10       ; exit if it does not match buffer size
    jmp quit
  @@:

; -----------------------------------------------------------------------------
; process .IF block one level a a time until there are no further nested blocks
; -----------------------------------------------------------------------------

    mov lbln, 0

  iter:
    invoke process_if,buf1,buf2,lbln
    test eax, eax                               ; EAX is the "loop again" flag. 0 = no, other = yes
    jz prnt
    mov lbln, ecx                               ; ECX contains the current label number

    push buf1                                   ; rotate buffers for next pass
    push buf2
    pop buf1
    pop buf2

    jmp iter

  prnt:

    print buf2,13,10

; -------------------------------------------------------------------------

  quit:

    ret

if2op endp

; 

process_if proc buf1:DWORD,buf2:DWORD,lbln:DWORD

  ; ---------
  ; arguments
  ; ---------
  ; buf1    The SOURCE buffer
  ; buf2    The TARGET buffer
  ; lbln    The current label number

  ; --------
  ; counters
  ; --------
    LOCAL lcnt      :DWORD                      ; lines of text count in 1st buffer
    LOCAL acnt      :DWORD                      ; argument count for line
  ; --------
  ; pointers
  ; --------
    LOCAL spos      :DWORD                      ; offset pointer for line reader
    LOCAL apos      :DWORD                      ; offset pointer for current append
    LOCAL parr      :DWORD                      ; array pointer for line arguments
    LOCAL pmain     :DWORD                      ; array main memory
    LOCAL pbuf      :DWORD                      ; pointer to current line buffer
  ; -----
  ; flags
  ; -----
    LOCAL iflag     :DWORD                      ; .IF flag
    LOCAL ifret     :DWORD                      ; iteration return value flag
    LOCAL jflag     :DWORD                      ; unconditional branch flag for JMP RET or RETN
  ; ---------
  ; variables
  ; ---------
    LOCAL endlbl    :DWORD                      ; variable to store ENDIF label
  ; -------
  ; buffers
  ; -------
    LOCAL buffer[1024]:BYTE

    push ebx
    push esi
    push edi

    mov eax, lbln
    mov endlbl, eax                             ; load endlbl with current label number
    add lbln, 1                                 ; increment current label number

    mov lcnt, rv(lfcnt,buf1)                    ; get line count

    mov iflag, 0
    mov ifret, 0
    mov jflag, 0

    mov spos, 0                                 ; zero both offset pointers
    mov apos, 0
    mov parr, rv(create_array,128,512)          ; create local array for arguments
    mov pmain, ecx
    mov pbuf, ptr$(buffer)

  ; =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  ;             main loop start
  ; =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  lpst:
    mov spos, rv(readline,buf1,pbuf,spos)       ; read line into local buffer
    test rv(tstline,pbuf), eax                  ; test if it has useful content
    jz bypass
    ;; invoke decomment,pbuf                       ; strip comment in line
    mov acnt, rv(get_line_args,pbuf,parr)       ; parse the line into its arguments
    test eax, eax
    jz bypass

    mov esi, parr

  ; ********************************************
  ;             switchi$ block start
  ; ********************************************
    switchi$ [esi]
    ; ************
      casei$ ".if"
    ; ************
        mov ifret, 1
        add iflag, 1
        cmp iflag, 1
        jg bypass

        mov apos, rv(rt_compares,parr,buf2,apos,lbln)

    ; ****************
      casei$ ".elseif"
    ; ****************
        cmp iflag, 1
        jg bypass
      ; ----------------------------------------------
      ; if last normal instruction is an unconditional
      ; branch, clear the jflag and do NOT write a
      ; following unused JMP.
      ; ----------------------------------------------
        .if jflag == 0
          mov apos, rv(apndstr,buf2,"    jmp lbl_",apos)    ; jmp end label
          mov apos, rv(apndstr,buf2,str$(endlbl),apos)
          mov apos, rv(apndstr,buf2,chr$(13,10),apos)
        .else
          mov jflag, 0
        .endif

        mov apos, rv(apndstr,buf2,chr$(13,10),apos)         ; next label
        mov apos, rv(apndstr,buf2,"  lbl_",apos)
        mov apos, rv(apndstr,buf2,str$(lbln),apos)
        mov apos, rv(apndstr,buf2,":",apos)
        mov apos, rv(apndstr,buf2,chr$(13,10),apos)
        add lbln, 1

        mov apos, rv(rt_compares,parr,buf2,apos,lbln)

    ; **************
      casei$ ".else"
    ; **************
        cmp iflag, 1
        jg bypass
      ; ----------------------------------------------
      ; if last normal instruction is an unconditional
      ; branch, clear the jflag and do NOT write a
      ; following unused JMP.
      ; ----------------------------------------------
        .if jflag == 0
          mov apos, rv(apndstr,buf2,"    jmp lbl_",apos)    ; jmp end label
          mov apos, rv(apndstr,buf2,str$(endlbl),apos)
          mov apos, rv(apndstr,buf2,chr$(13,10),apos)
        .else
          mov jflag, 0
        .endif

        mov apos, rv(apndstr,buf2,chr$(13,10),apos)         ; next label
        mov apos, rv(apndstr,buf2,"  lbl_",apos)
        mov apos, rv(apndstr,buf2,str$(lbln),apos)
        mov apos, rv(apndstr,buf2,":",apos)
        mov apos, rv(apndstr,buf2,chr$(13,10),apos)
        add lbln, 1

    ; ***************
      casei$ ".endif"
    ; ***************
        sub iflag, 1
        cmp iflag, 0
        jg bypass

        mov apos, rv(apndstr,buf2,chr$(13,10),apos)
        mov apos, rv(apndstr,buf2,"  lbl_",apos)
        mov apos, rv(apndstr,buf2,str$(endlbl),apos)
        mov apos, rv(apndstr,buf2,":",apos)
        mov apos, rv(apndstr,buf2,chr$(13,10),apos)

    ; ******
      elsei$
    ; ******
      ; -------------------------------------
      ; copy and evaluate normal instructions
      ; -------------------------------------
        mov apos, rv(apndstr,buf2,pbuf,apos)
        mov apos, rv(apndstr,buf2,chr$(13,10),apos)
      ; -----------------------------------
      ; set jflag on any of following words
      ; -----------------------------------
        switchi$ [esi]
          casei$ "jmp"
            mov jflag, 1
          casei$ "ret"
            mov jflag, 1
          casei$ "retn"
            mov jflag, 1
        endswi$

    endswi$

    jmp swout
  ; ********************************************
  ;             switchi$ block end
  ; ********************************************

  bypass:
    mov apos, rv(apndstr,buf2,pbuf,apos)
    mov apos, rv(apndstr,buf2,chr$(13,10),apos)

  swout:
    sub lcnt, 1
    jnz lpst
  ; =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  ;              main loop end
  ; =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*

    free parr
    free pmain

  ; -----------------
  ; set return values
  ; -----------------
    .if ifret == 1      ; if flag is set
      mov eax, 1        ; return 1 to iterate again
    .else
      xor eax, eax      ; else return zero to finished
    .endif

    mov ecx, lbln       ; return the current label number in ECX

    pop edi
    pop esi
    pop ebx

    ret

process_if endp

; 

rt_compares proc parr:DWORD,buf2:DWORD,apos:DWORD,lbln:DWORD

comment * ------------------------------------------------------
        This procedure recieves the argument list from an .IF or
        .ELSEIF test and converts it to the comparison and Jxx.
        If it can be determined that it is a test of a register
        to ZERO, the mnemonic TEST is used instead.
        ------------------------------------------------------ *

    push ebx
    push esi
    push edi

    mov esi, parr

    mov eax, [esi+4]            ; copy string address into EAX
    call testreg                ; test if 2nd argument is a register
    test eax, eax
    jz write_cmp                ; skip if not an integer register

    switch$ [esi+8]             ; test the logic operator
      case$ "=="
        jmp tst0
      case$ "!="
        jmp tst0
      else$
        jmp write_cmp
    endsw$

  tst0:
    switchi$ [esi+12]
      casei$ "0"
        jmp write_test
      casei$ "00h"
        jmp write_test
      elsei$
        jmp write_cmp
    endswi$

  write_test:
    mov apos, rv(apndstr,buf2,"    test ",apos)
    mov apos, rv(apndstr,buf2,[esi+4],apos)
    mov apos, rv(apndstr,buf2,", ",apos)
    mov apos, rv(apndstr,buf2,[esi+4],apos)
    mov apos, rv(apndstr,buf2,chr$(13,10),apos)

    switch$ [esi+8]             ; test the comparison operator
      case$ "=="
        mov apos, rv(apndstr,buf2,"    jnz lbl_",apos)
        mov apos, rv(apndstr,buf2,str$(lbln),apos)
        mov apos, rv(apndstr,buf2,chr$(13,10),apos)

      case$ "!="
        mov apos, rv(apndstr,buf2,"    jz  lbl_",apos)
        mov apos, rv(apndstr,buf2,str$(lbln),apos)
        mov apos, rv(apndstr,buf2,chr$(13,10),apos)

    endsw$

    jmp quit

  write_cmp:
    mov apos, rv(apndstr,buf2,"    cmp ",apos)
    mov apos, rv(apndstr,buf2,[esi+4],apos)
    mov apos, rv(apndstr,buf2,", ",apos)
    mov apos, rv(apndstr,buf2,[esi+12],apos)
    mov apos, rv(apndstr,buf2,chr$(13,10),apos)

    switch$ [esi+8]             ; test the comparison operator
      case$ "=="
        mov apos, rv(apndstr,buf2,"    jne lbl_",apos)
      case$ "="
        mov apos, rv(apndstr,buf2,"    jne lbl_",apos)      ; basic notation
      case$ "!="
        mov apos, rv(apndstr,buf2,"    je  lbl_",apos)
      case$ "<>"
        mov apos, rv(apndstr,buf2,"    je  lbl_",apos)       ; basic notation
      case$ ">="
        mov apos, rv(apndstr,buf2,"    jl  lbl_",apos)
      case$ "=>"
        mov apos, rv(apndstr,buf2,"    jl  lbl_",apos)
      case$ "<="
        mov apos, rv(apndstr,buf2,"    jg  lbl_",apos)
      case$ "=<"
        mov apos, rv(apndstr,buf2,"    jg  lbl_",apos)
      case$ "<"
        mov apos, rv(apndstr,buf2,"    jge lbl_",apos)
      case$ ">"
        mov apos, rv(apndstr,buf2,"    jle lbl_",apos)
      else$
        print "    ERROR Invalid runtime comparison operator : "
        print [esi+8],13,10
        jmp quit
    endsw$

    mov apos, rv(apndstr,buf2,str$(lbln),apos)
    mov apos, rv(apndstr,buf2,chr$(13,10),apos)

  quit:
    mov eax, apos

    pop edi
    pop esi
    pop ebx

    ret

rt_compares endp

; 

end start





Practice artwork :)

; =-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=-=*=

; <*>=--=<*>=--=<*>=--=<*>=--=<*>=--=<*>=--=<*>=--=<*>=--=<*>=--=<*>=--=<*>

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -









